#include<bits/stdc++.h>
using namespace std;
int n,q, res;
long long h[200050];
long long d[200050], p[200050];
bool pr;
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q;
    for(int i=1; i<=n; i++)
        cin >> d[i] >> p[i];
    for(int i=1; i<=q; i++)
    {
        cin >> h[i];
        pr = 0;
        for(int i=1; i<=n; i++)
        {
            h[i] = h[i] - d[i];
            res++;
            if(h[i] >= 0)
                goto ovde;
        }
        if(pr == 0)
        {
            cout << "-1 \n";
            pr = 1;
        }
        ovde:
        if(pr == 0)
            cout << res << "\n";
    }
    return 0;
}